Subject: Re: [PATCH v3 19/20] RDMA: Add irdma Kconfig/Makefile and remove i40iw

From: Jason Gunthorpe <[email-masked]>
Date: Wed, 11 Dec 2019 16:02:00 -0400

On Mon, Dec 09, 2019 at 02:49:34PM -0800, Jeff Kirsher wrote:
> From: Shiraz Saleem <[email-masked]>
> 
> Add Kconfig and Makefile to build irdma driver.
> 
> Remove i40iw driver. irdma is the replacement driver
> that supports X722.

I looked through this for a litle while, it is very very big. I'd like
some of the other people who have sent drivers lately to give it a go
over as well..

A few broad comments 
 - Do not use the 'err1', 'err2', etc labels for goto unwind
 - Please check all uses of rcu, I could not see why some existed
 - Use the new rdma mmap api. The whole mmap flow looked wonky to me
 - Check explicit casts, I saw alot that where questionable
 - Make sure rdma-core still builds after all the kernel uapi header
   changes - looks to me like it breaks the build
 - Check that atomics should not actually be a refcount_t
 - New drivers should use the ops->driver_unregister flow
 - devlink in the rdma driver seems very strange, I thought this
   should be in the PCI function driver?
 - The whole cqp_compl_thread thing looks really weird

Jason